
#include "inputArm.h"
#include "servoArm.h"
#include "transformer.h"
#include "returnValues.h"

#include "colours.h"

int main(int argc, char * argv[]) {

   servoArm_t    OUT, OUT2;
   armTrainer_t  INP;
   transformSet_t BRIDGE;
   unsigned int  i;
   
   if (argc < 5) {
     printf("Usage %s devicein configin deviceout configout\n", argv[0]);
     return 0;
   }   
   
   printf("Initializing\n");
   if (armTrainerInit(&INP, argv[1], argv[2]) != OK) {
     printf("port open error\n");
     return 0;
   }
   if (servoArmInit(&OUT, argv[3], argv[4]) != OK) {
     printf("port open error\n");
     return 0;
   }
//   if (servoArmInit(&OUT2, "/dev/ttyUSB2", "arm8.tf") != OK) {
//     printf("port open error\n");
//     return 0;
//   }

   
   transZeroInput(&(OUT.buffer)) ; 
//   transZeroInput(&(OUT2.buffer)) ;  
   clrscr();
            
   if (transformSetInit(&BRIDGE, 1) != OK) {
     printf("bridge init err\n");
     return 0;
   }

   if ( transformSetLoadFrom(&BRIDGE, "bridge.tf") != OK) {
     printf("bridge init err\n");
     return 0;
   }
   
   gotoxy(20,1);
   transformSetDump(&BRIDGE);
    
        
   while(1) {               
   
     transCalc(&(INP.buffer));
     
     for (i = 0; i < OUT.buffer.count; i++)  OUT.buffer.in[i] = 0;
//     for (i = 0; i < OUT2.buffer.count; i++)  OUT2.buffer.in[i] = 0;
     
     transformSetDo(&BRIDGE, INP.buffer.out, OUT.buffer.in);
//     transformSetDo(&BRIDGE, INP.buffer.out, OUT2.buffer.in);
     
     transCalc(&(OUT.buffer));
     servoArmSync(&OUT); 
     
//     transCalc(&(OUT2.buffer));
//     servoArmSync(&OUT2); 
     
     gotoxy(2,1);
     
   //  transDump(&(INP.buffer));   
   //  printf("--\n"); 
   //  transDump(&(OUT.buffer));
     
   usleep(20000);
   
   }
  

  return 0;
}

